import { GraphQLResolveInfo, GraphQLSchema } from 'graphql';
import { QueryMap, BindingOptions } from './types';
export declare class Binding {
    query: QueryMap;
    mutation: QueryMap;
    schema: GraphQLSchema;
    private fragmentReplacements;
    constructor({schema, fragmentReplacements}: BindingOptions);
    request<T = any>(query: string, variables?: {
        [key: string]: any;
    }): Promise<T>;
    delegate(operation: 'query' | 'mutation', fieldName: string, args: {
        [key: string]: any;
    }, context: {
        [key: string]: any;
    }, info?: GraphQLResolveInfo | string): Promise<any>;
}
