"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_tools_1 = require("graphql-tools");
var info_1 = require("./info");
var Handler = /** @class */ (function () {
    function Handler(schema, fragmentReplacements, operation) {
        this.schema = schema;
        this.fragmentReplacements = fragmentReplacements;
        this.operation = operation;
    }
    Handler.prototype.get = function (target, rootFieldName) {
        var _this = this;
        return function (args, info) {
            var operation = _this.operation;
            info = info_1.buildInfo(rootFieldName, operation, _this.schema, info);
            return graphql_tools_1.delegateToSchema(_this.schema, _this.fragmentReplacements, operation, rootFieldName, args || {}, {}, info);
        };
    };
    return Handler;
}());
exports.Handler = Handler;
//# sourceMappingURL=handler.js.map